# Errai Framework

Errai is a Java/GWT web framework for building rich-client web applications. It provides declarative, annotation-driven features that greatly ease development of large-scale applications, including:

* [CDI-like dependency injection](http://docs.jboss.org/errai/latest/errai/reference/html_single/#sid-5931402)
* [A bidirectional message bus](http://docs.jboss.org/errai/latest/errai/reference/html_single/#sid-5931263)
* [Remote Procedure Calls (via the message bus or HTTP)](http://docs.jboss.org/errai/latest/errai/reference/html_single/#sid-5931313)
* [Client-side and client-server CDI events](http://docs.jboss.org/errai/latest/errai/reference/html_single/#sid-21758054)
* [Client-side templating](http://docs.jboss.org/errai/latest/errai/reference/html_single/#sid-51806600)
* [Two-way data-binding](http://docs.jboss.org/errai/latest/errai/reference/html_single/#sid-51282340)
* [Browser-friendly navigation](http://docs.jboss.org/errai/latest/errai/reference/html_single/#sid-54493676)
* [Role-based access control for RPC services and other Errai features](http://docs.jboss.org/errai/latest/errai/reference/html_single/#_errai_security)

## Learning about Errai

For those who prefer hands-on learning, checkout the [Errai Tutorial](https://github.com/errai/errai-tutorial) to see working Errai application, or learn how to start your own project with our [Getting Started Guide](http://erraiframework.org/getting-started/index.html#SetupPage).

And for those who prefer the top-down approach, you can find a detailed descriptions of how to use Errai in our [documentation](http://docs.jboss.org/errai/latest/errai/reference/html_single/).

## Errai News

To keep appraised of new features and releases:

* Find our most recent major releases on our [project website](http://erraiframework.org).
* Follow [@jbosserrai](https://twitter.com/jbosserrai) on Twitter.
* Checkout our [blog](http://errai-blog.blogspot.ca/).

## Errai Community Support

Visit our [forum](https://developer.jboss.org/en/errai) or join our IRC channel (#errai on freenode) to share solutions.

## Contributing to Errai

Report bugs or request features through our [issue tracker](https://issues.jboss.org/projects/ERRAI).

Contribute code through pull requests to this repository. See our [contributing guidelines](CONTRIBUTING.md) for more details.

## Useful Links

* [Website](http://erraiframework.org)
* [Documentation](http://docs.jboss.org/errai/latest/errai/reference/html_single/)
* [Forum](https://developer.jboss.org/en/errai)
* [Twitter](https://twitter.com/jbosserrai)
* [Issue Tracker](https://issues.jboss.org/projects/ERRAI)
* [Blog](http://errai-blog.blogspot.ca/)
* [Getting Started Guide](http://erraiframework.org/getting-started/index.html#SetupPage)
* [Errai Tutorial](https://github.com/errai/errai-tutorial)
* [Contributing Guidelines](CONTRIBUTING.md)
